%define anolis_release 1
%global tex_texinfo %{_datadir}/texlive/texmf-dist/tex/texinfo

Summary: Tools needed to create Texinfo format documentation files
Name: texinfo
Version: 7.0.1
Release: %{anolis_release}%{?dist}
License: GPLv3+
Url: http://www.gnu.org/software/texinfo/
Source0: https://ftp.gnu.org/gnu/texinfo/texinfo-%{version}.tar.xz
Source1: https://ftp.gnu.org/gnu/texinfo/texinfo-%{version}.tar.xz.sig

BuildRequires: make
BuildRequires: gcc
BuildRequires: perl-generators
BuildRequires: ncurses-devel, help2man, perl(Data::Dumper)
BuildRequires: perl(Locale::Messages), perl(Unicode::EastAsianWidth), perl(Text::Unidecode)
BuildRequires: perl(Storable), perl(Unicode::Normalize), perl(File::Copy)
Requires: less grep

# Texinfo perl packages are not installed in default perl library dirs
%global __provides_exclude ^perl\\(.*Texinfo.*\\)$
%global __requires_exclude ^perl\\(.*Texinfo.*\\)$

%description
Texinfo is a documentation system that can produce both online
information and printed output from a single source file. The GNU
Project uses the Texinfo file format for most of its documentation.

Install texinfo if you want a documentation system for producing both
online and print documentation from the same source file and/or if you
are going to write documentation for the GNU Project.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package -n info
Summary: A stand-alone TTY-based reader for GNU texinfo documentation
Provides: /sbin/install-info

%description -n info
The GNU project uses the texinfo file format for much of its
documentation. The info package provides a standalone TTY-based
browser program for viewing texinfo files.

%package tex
Summary: Tools for formatting Texinfo documentation files using TeX
Requires: texinfo = %{version}-%{release}
Requires: tex(tex) tex(epsf.tex)
Requires(post): %{_bindir}/texconfig-sys
Requires(postun): %{_bindir}/texconfig-sys
Provides: tex-texinfo
Provides: texlive-texinfo
Obsoletes: texlive-texinfo <= 9:2019-15

%description tex
Texinfo is a documentation system that can produce both online
information and printed output from a single source file. The GNU
Project uses the Texinfo file format for most of its documentation.

The texinfo-tex package provides tools to format Texinfo documents
for printing using TeX.

%prep
%autosetup -p1

%build
%configure --with-external-Text-Unidecode \
           --with-external-libintl-perl \
           --with-external-Unicode-EastAsianWidth \
           --disable-perl-xs
%make_build

%install
mkdir -p ${RPM_BUILD_ROOT}/sbin

%make_install

mkdir -p $RPM_BUILD_ROOT%{tex_texinfo}
install -p -m644 doc/texinfo.tex doc/txi-??.tex $RPM_BUILD_ROOT%{tex_texinfo}

mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mv $RPM_BUILD_ROOT%{_bindir}/install-info $RPM_BUILD_ROOT%{_sbindir}

%find_lang %{name}
%find_lang %{name}_document

%generate_compatibility_deps

%check
export ALL_TESTS=yes
%make_build check

%post tex
%{_bindir}/texconfig-sys rehash 2> /dev/null || :

%postun tex
%{_bindir}/texconfig-sys rehash 2> /dev/null || :

%transfiletriggerin -n info -- %{_infodir}/*.info* %{_infodir}/texinfo.*
if [ $1 -eq 1 -o $2 -eq 1 ]; then
    while [ -n "$3" ]; do
	if [ -f "$3" ]; then
	    LESSOPEN="|/usr/bin/lesspipe.sh %s" LESS_ADVANCED_PREPROCESSOR=1 less "$3" | grep -q -e INFO-DIR-SECTION && %{_bindir}/install-info "$3" --dir=%{_infodir}/dir
	fi
	shift
    done
fi

%transfiletriggerun -n info -- %{_infodir}/*.info* %{_infodir}/texinfo.*
if [ $2 -eq 0 ]; then
    while [ -n "$3" ]; do
	if [ -f "$3" ]; then
	    LESSOPEN="|/usr/bin/lesspipe.sh %s" LESS_ADVANCED_PREPROCESSOR=1 less "$3" | grep -q -e INFO-DIR-SECTION && %{_bindir}/install-info "$3" --dir=%{_infodir}/dir --remove
	fi
	shift
    done
fi

%files -f %{name}.lang -f %{name}_document.lang
%dir %{abidir}
%license COPYING
%{_bindir}/makeinfo
%{_bindir}/texi2any
%{abidir}/texi2any-option.list
%{_bindir}/pod2texi
%{abidir}/pod2texi-option.list
%{_datadir}/texinfo
%{_infodir}/texinfo*
%{_infodir}/texi2any_api.info*            
%{_infodir}/texi2any_internals.info*
%{_mandir}/man1/makeinfo.1*
%{_mandir}/man5/texinfo.5*
%{_mandir}/man1/texi2any.1*
%{_mandir}/man1/pod2texi.1*


%files doc
%doc AUTHORS ChangeLog NEWS README TODO

%files -n info
%license COPYING
%{_bindir}/info
%{_infodir}/info-stnd.info*
%{_sbindir}/install-info
%{abidir}/info-option.list
%{abidir}/install-info-option.list
%{_mandir}/man1/info.1*
%{_mandir}/man1/install-info.1*
%{_mandir}/man5/info.5*
%ghost %{_infodir}/dir
%ghost %attr(644, root, root) %{_infodir}/dir.old

%files tex
%{_bindir}/texindex
%{_bindir}/texi2dvi
%{_bindir}/texi2pdf
%{_bindir}/pdftexi2dvi
%{abidir}/texindex-option.list
%{abidir}/texi2dvi-option.list
%{tex_texinfo}/
%{_mandir}/man1/texindex.1*
%{_mandir}/man1/texi2dvi.1*
%{_mandir}/man1/texi2pdf.1*
%{_mandir}/man1/pdftexi2dvi.1*

%changelog
* Thu Dec 1 2022 Funda Wang <fundawang@yeah.net> - 7.0.1-1
- New version 7.0.1

* Mon Nov 21 2022 Funda Wang <fundawang@yeah.net> - 7.0-1
- New version 7.0

* Thu Nov 17 2022 Funda Wang <fundawang@yeah.net> - 6.8-6
- Rework trigger scriptlets from openmandriva so that it does not depend on
  contrib/fix-info-dir, which will be dropped in texinfo >= 7.0

* Wed Oct 26 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 6.8-5
- optimise spec file

* Thu Oct 13 2022 Funda Wang <fundawang@yeah.net> - 6.8-4
- Add patches for supporting zstd compression for info pages

* Sat Oct 08 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 6.8-3
- add doc package

* Fri Apr 29 2022 gaochang <taifu.gc@alibaba-inc.com> - 6.8-2
- Fix: Error messages overflowing when performing package scriptlet.

* Wed Mar 09 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 6.8-1
- init from upstream 6.8
